Package com.io7m.jtensors.core.parameterized.vectors

# Class PVector3I.Builder<T>

java.lang.Object
com.io7m.jtensors.core.parameterized.vectors.PVector3I.Builder<T>

Enclosing class:
  PVector3I<T>

    public static final class PVector3I.Builder<T>
    extends java.lang.Object

Builds instances of type `PVector3I`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `PVector3I<T>` | `build()` | Builds a new `PVector3I`.
  `PVector3I.Builder<T>` | `from​(PVector3IType<T> instance)` | Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVector3IType` instance.
  `PVector3I.Builder<T>` | `from​(VectorReadable2IType instance)` | Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2IType` instance.
  `PVector3I.Builder<T>` | `from​(VectorReadable3IType instance)` | Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable3IType` instance.
  `PVector3I.Builder<T>` | `setX​(int x)` | Initializes the value for the `x` attribute.
  `PVector3I.Builder<T>` | `setY​(int y)` | Initializes the value for the `y` attribute.
  `PVector3I.Builder<T>` | `setZ​(int z)` | Initializes the value for the `z` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final PVector3I.Builder<T> from​(VectorReadable3IType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable3IType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector3I.Builder<T> from​(VectorReadable2IType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2IType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector3I.Builder<T> from​(PVector3IType<T> instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVector3IType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setX

    public final PVector3I.Builder<T> setX​(int x)
    Initializes the value for the `x` attribute.
    Parameters:
      `x` - The value for x
    Returns:
      `this` builder for use in a chained invocation

  - ### setY

    public final PVector3I.Builder<T> setY​(int y)
    Initializes the value for the `y` attribute.
    Parameters:
      `y` - The value for y
    Returns:
      `this` builder for use in a chained invocation

  - ### setZ

    public final PVector3I.Builder<T> setZ​(int z)
    Initializes the value for the `z` attribute.
    Parameters:
      `z` - The value for z
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public PVector3I<T> build()
    Builds a new `PVector3I`.
    Returns:
      An immutable instance of PVector3I
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing